import { type autocompletion } from "@codemirror/autocomplete";
import { type JsonRpc, type Request } from "./jsonRpc/index.mts";
import { type Position } from "./lsp/conversion.mts";
import { type EventEmitter } from "eventemitter3";
type CompletionConfig = NonNullable<Parameters<typeof autocompletion>[0]>;
export interface LspAutocompleteConfig extends CompletionConfig {
    client: JsonRpc;
    bus: EventEmitter;
}
export interface CompletionItemResolveRequest extends Request {
    method: "completionItem/resolve";
    params: {
        label: string;
        insertTextFormat: number;
        insertText: string;
        kind: number;
        data: {
            position: Position;
            textDocument: {
                uri: string;
            };
        };
    };
}
export {};
//# sourceMappingURL=autocompletion.d.mts.map