import { type Request } from "../jsonRpc/index.mts";
export interface Position {
    character: number;
    line: number;
}
export interface Range {
    start: Position;
    end: Position;
}
export interface TextDocumentPublishDiagnosticsDiagnostic {
    code: number;
    message: string;
    range: Range;
    severity: number;
    source: string;
}
export interface TextDocumentPublishDiagnosticsRequest extends Request {
    method: "textDocument/publishDiagnostics";
    params: {
        diagnostics: TextDocumentPublishDiagnosticsDiagnostic[];
    };
}
export declare function getCharacterFromPosition(text: string, position: Position): number;
export declare function getPositionFromCharacter(text: string, character: number): Position;
export declare function getDiagnosticSeverity(severity: number): "error" | "warning" | "info";
//# sourceMappingURL=conversion.d.mts.map